﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;

namespace TestDocIoMailMerge
{
    public partial class Form1 : Form
    {
        int ID = 10444;
        int iIndex = 0;
        string dataPath = null;
        string connString = null;
        IWordDocument doc = null;

        OleDbConnection conn = null;
        OleDbDataAdapter da = null;
        OleDbCommand cmd = null;

        Syncfusion.DocIO.DLS.WordDocument oDoc = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void btDownload_Click(object sender, EventArgs e)
        {
            this.MergeField();
        }

        private void MergeField()
        {
            oDoc = new Syncfusion.DocIO.DLS.WordDocument();

            oDoc.Open(this.txtInputFile.Text);

            oDoc.MailMerge.RemoveEmptyParagraphs = true;

            //Using Merge events to do conditional formatting during runtime.
            oDoc.MailMerge.MergeField += new MergeFieldEventHandler(MailMerge_MergeField);

            iIndex = 0;

            oDoc.MailMerge.ExecuteGroup(GetTestUsers());

            oDoc.Close();
        }

        private void MailMerge_MergeField(object sender, MergeFieldEventArgs args)
        {
            //Conditionally format data during Merge.
            if (args.RowIndex % 2 == 0)
            {
                args.CharacterFormat.TextColor = Color.DarkBlue;
            }
            string sFileName = iIndex.ToString() + ".doc";
            iIndex += 1;
            oDoc.Save(@"e:\Tests\Docs\" + sFileName, FormatType.Doc);

            if (args.FieldName.Equals("UserProfile"))
            {
                
                if (args.TableName.Equals("Users"))
                {
                    DataTable table = new DataTable();
                    table.TableName = "Projects";

                    table.Columns.Add("ProjectName");

                    DataRow row = table.NewRow();
                    row[0] = "Proj 1";
                    table.Rows.Add(row);

                    row = table.NewRow();
                    row[0] = "Proj 2";
                    table.Rows.Add(row);
                    args.Document.MailMerge.ExecuteGroup(table);
                }
            }

        }

        private DataTable GetTestUsers()
        {
            DataTable table = new DataTable();

            table.Columns.Add("UserName");
            table.Columns.Add("UserProfile");
            table.Columns.Add("ProjectID");

            DataRow row = table.NewRow();
            row[0] = "Dimitri";
            row[1] = "Admin";
            row[2] = "1";
            table.Rows.Add(row);

            row = table.NewRow();
            row[0] = "Evan";
            row[1] = "Resp";
            row[2] = "2";
            table.Rows.Add(row);

            table.TableName = "Users";

            return table;
        }

        private void btnOpenInput_Click(object sender, EventArgs e)
        {
            if (this.openFileDialog1.ShowDialog() == DialogResult.OK)
                this.txtInputFile.Text = this.openFileDialog1.FileName;
        }

        private void btnOuputFile_Click(object sender, EventArgs e)
        {
            if (this.saveFileDialog1.ShowDialog() == DialogResult.OK)
                this.txtOuputFile.Text = this.saveFileDialog1.FileName;
        }

        private void btnOpenDB_Click(object sender, EventArgs e)
        {
            if (this.openFileDialog2.ShowDialog() == DialogResult.OK)
                this.txtDB.Text = this.openFileDialog2.FileName;
        }
    }
}
